// {{{RME classifier 'Logical View::HelloWorld'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "HelloWorld.h"
#endif

#include <RTSystem/HelloWorld.h>
#include <HelloWorld.h>

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static RTActor * new_HelloWorld_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new HelloWorld_Actor( _rts, _ref );
}

const RTActorClass HelloWorld =
{
	(const RTActorClass *)0
  , "HelloWorld"
  , (RTVersionId)0
  , 0
  , (const RTRelayDescriptor *)0
  , new_HelloWorld_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
  , "Active"
};

#define SUPER RTActor

HelloWorld_Actor::HelloWorld_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

HelloWorld_Actor::~HelloWorld_Actor( void )
{
}

// {{{RME transition ':TOP:Initial:Initial'
INLINE_METHODS void HelloWorld_Actor::transition1_Initial( const void * rtdata, RTProtocol * rtport )
{
	// {{{USR
	cout<<"Hello,World"<<endl;
	// }}}USR
}
// }}}RME

INLINE_CHAINS void HelloWorld_Actor::chain1_Initial( void )
{
	// transition ':TOP:Initial:Initial'
	rtgChainBegin( 1, "Initial" );
	rtgTransitionBegin();
	transition1_Initial( msg->data, msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

void HelloWorld_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; stateIndex = rtg_parent_state[ stateIndex - 1 ] )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					chain1_Initial();
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		case 2:
			// {{{RME state ':TOP:Active'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			break;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * HelloWorld_Actor::getActorData( void ) const
{
	return &HelloWorld_Actor::rtg_class;
}

const RTActor_class HelloWorld_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 2
  , HelloWorld_Actor::rtg_parent_state
  , &HelloWorld
  , 0
  , (const RTComponentDescriptor *)0
  , 0
  , (const RTPortDescriptor *)0
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId HelloWorld_Actor::rtg_parent_state[] =
{
	0
  , 1
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
