// {{{RME classifier 'Logical View::EletronicLock'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "EletronicLock.h"
#endif

#include <RTSystem/LockSystem.h>
#include <EletronicLock.h>

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
// }}}USR
// }}}RME

// {{{RME tool 'OT::Cpp' property 'GenerateDefaultConstructor'
EletronicLock::EletronicLock( void )
{
	rtg_init1();
}
// }}}RME

// {{{RME tool 'OT::Cpp' property 'GenerateDestructor'
EletronicLock::~EletronicLock( void )
{
}
// }}}RME

// {{{RME tool 'OT::Cpp' property 'GenerateCopyConstructor'
EletronicLock::EletronicLock( const EletronicLock & rtg_arg )
	: rtg_state_EletronicLock( rtg_arg.rtg_state_EletronicLock )
{
}
// }}}RME

// {{{RME tool 'OT::Cpp' property 'GenerateAssignmentOperator'
EletronicLock & EletronicLock::operator=( const EletronicLock & rtg_arg )
{
	if( this != &rtg_arg )
	{
	}
	return *this;
}
// }}}RME

void EletronicLock::rtg_init1( void )
{
	// {{{RME transition ':TOP:Initial:Initial'
	{
		// {{{USR
		printf("********************************\n");
		printf(" ACME  Eletronic Lock System \n");
		printf("********************************\n\n");
		// }}}USR
	}
	// }}}RME
	rtg_state_EletronicLock.state = 2U;
}

// {{{RME operation 'Number(char)'
void EletronicLock::Number( char num )
{
	unsigned char rtg_state = rtg_state_EletronicLock.state;
	for(;;)
	{
		switch( rtg_state )
		{
		case 2U:
			// {{{RME state ':TOP:Locked'
			// {{{RME transition ':TOP:Locked:J432EBBAA0374:question' guard '1'
			if(
				// {{{USR
				num == '?'
				// }}}USR
				)
			// }}}RME
			{
				// {{{RME transition ':TOP:Locked:J432EBBAA0374:question'
				{
					// {{{USR
					printf(" Locked Help Goes Here\n");
					// }}}USR
				}
				// }}}RME
				rtg_state_EletronicLock.state = 2U;
				return;
			}
			// {{{RME transition ':TOP:Locked:J432EBC7202FF:Number1' guard '1'
			if(
				// {{{USR
				num == '1'
				// }}}USR
				)
			// }}}RME
			{
				// {{{RME transition ':TOP:Locked:J432EBC7202FF:Number1'
				{
					// {{{USR

					// }}}USR
				}
				// }}}RME
				rtg_state_EletronicLock.state = 4U;
				return;
			}
			rtg_state = 1U;
			break;
			// }}}RME
		case 3U:
			// {{{RME state ':TOP:Unlocked'
			// {{{RME transition ':TOP:Unlocked:J432EBC6E0001:lockIsClosed' guard '1'
			if(
				// {{{USR
				num == 'L'
				// }}}USR
				)
			// }}}RME
			{
				// {{{RME transition ':TOP:Unlocked:J432EBC6E0001:lockIsClosed'
				{
					// {{{USR
					printf("The lock is LOCKED\n");
					// }}}USR
				}
				// }}}RME
				rtg_state_EletronicLock.state = 2U;
				return;
			}
			// {{{RME transition ':TOP:Unlocked:J432EBC790255:question' guard '1'
			if(
				// {{{USR
				num == '?'
				// }}}USR
				)
			// }}}RME
			{
				// {{{RME transition ':TOP:Unlocked:J432EBC790255:question'
				{
					// {{{USR
					printf("Unlock Help Goes Here\n");
					// }}}USR
				}
				// }}}RME
				rtg_state_EletronicLock.state = 3U;
				return;
			}
			rtg_state = 1U;
			break;
			// }}}RME
		case 4U:
			// {{{RME state ':TOP:Unlocking'
			// {{{RME transition ':TOP:Unlocking:J432EBE49003B:InputRcvd'
			{
				// {{{USR

				// }}}USR
			}
			// }}}RME
			// {{{RME choicePoint ':TOP:IsQuestion'
			if(
				// {{{USR
				num == '?'
				// }}}USR
				)
			// }}}RME
			{
				// {{{RME transition ':TOP:IsQuestion:True'
				{
					// {{{USR
					printf("Unlocking Help Goes Here\n");
					// }}}USR
				}
				// }}}RME
				rtg_state_EletronicLock.state = 4U;
			}
			else
			{
				// {{{RME transition ':TOP:IsQuestion:False'
				{
					// {{{USR

					// }}}USR
				}
				// }}}RME
				// {{{RME choicePoint ':TOP:IsTwo'
				if(
					// {{{USR
					num == '2'
					// }}}USR
					)
				// }}}RME
				{
					// {{{RME transition ':TOP:IsTwo:True'
					{
						// {{{USR
						printf("The lock is UNLOCKED\n");
						// }}}USR
					}
					// }}}RME
					rtg_state_EletronicLock.state = 3U;
				}
				else
				{
					// {{{RME transition ':TOP:IsTwo:False'
					{
						// {{{USR
						printf("Sorry, that is not the right conbination\n");
						// }}}USR
					}
					// }}}RME
					rtg_state_EletronicLock.state = 2U;
				}
			}
			return;
			// }}}RME
		default:
			return;
		}
	}
}
// }}}RME

// {{{RME operation 'main(char*,int)'
int main( char * argv[], int argc )
{
	// {{{USR
	EletronicLock theLock;
	char c;
	do{
	theLock.Number(c);
	c=_getch();
	}
	while (c!='q');
	return 1;
	// }}}USR
}
// }}}RME

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
