// {{{RME classifier 'Logical View::Battleship'

#ifndef Battleship_H
#define Battleship_H

#ifdef PRAGMA
#pragma interface "Battleship.h"
#endif

#include <RTSystem/World.h>
#include <SonarSignals.h>

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR

// }}}USR
// }}}RME

extern const RTActorClass Battleship;

#define SUPER RTActor
class Battleship_Actor : public RTActor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME port 'timer'
	Timing::Base timer;
	// }}}RME
	// {{{RME port 'sonar'
	SonarSignals::Base sonar;
	// }}}RME

public:
	Battleship_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~Battleship_Actor( void );
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME transition ':TOP:Initial:Initial'
	INLINE_METHODS void transition1_Initial( const void * rtdata, RTProtocol * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Active:J432B3819009A:sendPing'
	INLINE_METHODS void transition2_sendPing( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Active:J432B381C00F6:swallowEcho'
	INLINE_METHODS void transition3_swallowEcho( const void * rtdata, SonarSignals::Base * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain2_sendPing( void );
	INLINE_CHAINS void chain3_swallowEcho( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* Battleship_H */

// }}}RME
