// {{{RME classifier 'Logical View::Ocean'

#ifndef Ocean_H
#define Ocean_H

#ifdef PRAGMA
#pragma interface "Ocean.h"
#endif

#include <RTSystem/World.h>
#include <SonarSignals.h>

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR

// }}}USR
// }}}RME

extern const RTActorClass Ocean;

#define SUPER RTActor
class Ocean_Actor : public RTActor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME
	// {{{RME classAttribute 'inRangeTime'
	const RTTimespec inRangeTime;
	// }}}RME
	// {{{RME classAttribute 'outRangeTime'
	const RTTimespec outRangeTime;
	// }}}RME

protected:
	// {{{RME port 'sonarSignals'
	SonarSignals::Conjugate sonarSignals;
	// }}}RME
	// {{{RME port 'timer'
	Timing::Base timer;
	// }}}RME

public:
	Ocean_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~Ocean_Actor( void );
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME transition ':TOP:Initial:Initial'
	INLINE_METHODS void transition1_Initial( const void * rtdata, RTProtocol * rtport );
	// }}}RME
	// {{{RME transition ':TOP:outRange:Junction2:goInRange'
	INLINE_METHODS void transition2_goInRange( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:inRange:Junction2:goOutRange'
	INLINE_METHODS void transition3_goOutRange( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:inRange:Junction3:sendEcho'
	INLINE_METHODS void transition5_sendEcho( const void * rtdata, SonarSignals::Conjugate * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain4_swallowPing( void );
	INLINE_CHAINS void chain2_goInRange( void );
	INLINE_CHAINS void chain5_sendEcho( void );
	INLINE_CHAINS void chain3_goOutRange( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];

public:
	static const RTFieldDescriptor rtg_Ocean_fields[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* Ocean_H */

// }}}RME
