// {{{RME classifier 'Logical View::SonarSignals'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "SonarSignals.h"
#endif

#include <RTSystem/World.h>
#include <SonarSignals.h>

const RTProtocolDescriptor SonarSignals::Base::rt_class =
{
	&RTRootProtocol::rt_class
  , &SonarSignals::Conjugate::rt_class
  , "SonarSignals"
  , 0
  , 3
  , SonarSignals::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor SonarSignals::Base::rt_signals[] =
{
	{
		"echo"
	  , &RTType_void
	  , SonarSignals::Base::rti_echo
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , SonarSignals::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , SonarSignals::Base::rti_rtUnbound
	}
};

const RTProtocolDescriptor SonarSignals::Conjugate::rt_class =
{
	&RTRootProtocol::rt_class
  , &SonarSignals::Base::rt_class
  , "SonarSignals"
  , 0
  , 3
  , SonarSignals::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor SonarSignals::Conjugate::rt_signals[] =
{
	{
		"ping"
	  , &RTType_void
	  , SonarSignals::Conjugate::rti_ping
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , SonarSignals::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , SonarSignals::Conjugate::rti_rtUnbound
	}
};

// }}}RME
