// {{{RME classifier 'Logical View::SonarSignals'

#ifndef SonarSignals_H
#define SonarSignals_H

#ifdef PRAGMA
#pragma interface "SonarSignals.h"
#endif

#include <RTSystem/World.h>

struct SonarSignals
{
	class Base : public RTRootProtocol
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum { rti_echo = rtiLast_RTRootProtocol + 1 };

	protected:
		enum { rtiLast_SonarSignals = rti_echo };

	public:
		inline RTInSignal echo( void );
		inline RTOutSignal ping( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RTRootProtocol
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum { rti_ping = rtiLast_RTRootProtocol + 1 };

	protected:
		enum { rtiLast_SonarSignals = rti_ping };

	public:
		inline RTInSignal ping( void );
		inline RTOutSignal echo( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline SonarSignals::Base::Base( void )
	: RTRootProtocol()
{
}

inline SonarSignals::Base::~Base( void )
{
}

inline RTInSignal SonarSignals::Base::echo( void )
{
	return RTInSignal( this, rti_echo );
}

inline RTOutSignal SonarSignals::Base::ping( void )
{
	return RTOutSignal( this, Conjugate::rti_ping, (const void *)0, &RTType_void );
}

inline SonarSignals::Conjugate::Conjugate( void )
	: RTRootProtocol()
{
}

inline SonarSignals::Conjugate::~Conjugate( void )
{
}

inline RTInSignal SonarSignals::Conjugate::ping( void )
{
	return RTInSignal( this, rti_ping );
}

inline RTOutSignal SonarSignals::Conjugate::echo( void )
{
	return RTOutSignal( this, Base::rti_echo, (const void *)0, &RTType_void );
}

#endif /* SonarSignals_H */

// }}}RME
