// {{{RME classifier 'Logical View::World'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "World.h"
#endif

#include <RTSystem/World.h>
#include <World.h>
#include <SonarSignals.h>
extern const RTActorClass Battleship;
extern const RTActorClass Ocean;

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static RTActor * new_World_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new World_Actor( _rts, _ref );
}

const RTActorClass World =
{
	(const RTActorClass *)0
  , "World"
  , (RTVersionId)0
  , 0
  , (const RTRelayDescriptor *)0
  , new_World_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
};

static const RTInterfaceDescriptor rtg_interfaces_ocean[] =
{
	{
		"sonarSignals"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_ocean[] =
{
	{
		0
	  , &SonarSignals::Base::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_battleship[] =
{
	{
		"sonar"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_battleship[] =
{
	{
		0
	  , &SonarSignals::Conjugate::rt_class
	}
};

#define SUPER RTActor

World_Actor::World_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

World_Actor::~World_Actor( void )
{
}

int World_Actor::_followOutV( RTBindingEnd & rtg_end, int rtg_compId, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_compId )
	{
	case 1:
		// ocean
		switch( rtg_portId )
		{
		case 0:
			// sonarSignals
			if( rtg_repIndex < 1 )
			{
				// battleship/sonar
				return battleship._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 2:
		// battleship
		switch( rtg_portId )
		{
		case 0:
			// sonar
			if( rtg_repIndex < 1 )
			{
				// ocean/sonarSignals
				return ocean._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	default:
		break;
	}
	return RTActor::_followOutV( rtg_end, rtg_compId, rtg_portId, rtg_repIndex );
}

void World_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * World_Actor::getActorData( void ) const
{
	return &World_Actor::rtg_class;
}

const RTActor_class World_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 1
  , World_Actor::rtg_parent_state
  , &World
  , 2
  , World_Actor::rtg_capsule_roles
  , 0
  , (const RTPortDescriptor *)0
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId World_Actor::rtg_parent_state[] =
{
	0
};

const RTComponentDescriptor World_Actor::rtg_capsule_roles[] =
{
	{
		"ocean"
	  , &Ocean
	  , RTOffsetOf( World_Actor, ocean )
	  , 1
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_ocean
	  , 1
	  , rtg_bindings_ocean
	}
  , {
		"battleship"
	  , &Battleship
	  , RTOffsetOf( World_Actor, battleship )
	  , 2
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_battleship
	  , 1
	  , rtg_bindings_battleship
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
