// {{{RME classifier 'Logical View::Controller'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Controller.h"
#endif

#include <RTSystem/Intersection.h>
#include <Controller.h>

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"south"
	  , &LightControl::Base::rt_class
	  , 1 // cardinality
	}
  , {
		"north"
	  , &LightControl::Base::rt_class
	  , 1 // cardinality
	}
  , {
		"east"
	  , &LightControl::Base::rt_class
	  , 1 // cardinality
	}
  , {
		"west"
	  , &LightControl::Base::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_Controller_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new Controller_Actor( _rts, _ref );
}

const RTActorClass Controller =
{
	(const RTActorClass *)0
  , "Controller"
  , (RTVersionId)0
  , 4
  , rtg_relays
  , new_Controller_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
  , "greenN"
  , "yellowN"
  , "greenE"
  , "yellowE"
};

#define SUPER RTActor

Controller_Actor::Controller_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

Controller_Actor::~Controller_Actor( void )
{
}

int Controller_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// south
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &south;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	case 1:
		// north
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &north;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	case 2:
		// east
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &east;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	case 3:
		// west
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &west;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

// {{{RME transition ':TOP:Initial:Initial'
INLINE_METHODS void Controller_Actor::transition1_Initial( const void * rtdata, RTProtocol * rtport )
{
	// {{{USR
	timer.informIn(RTTimespec( 4, 0) ); 
	south.green().send();
	north.green().send();
	east.red().send();
	west.red().send();
	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:greenN:J432ED7320101:t1'
INLINE_METHODS void Controller_Actor::transition2_t1( const void * rtdata, Timing::Base * rtport )
{
	// {{{USR
	south.yellow().send();
	north.yellow().send();
	timer.informIn(RTTimespec( 2, 0) ); 
	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:yellowN:J432ED7430325:t1'
INLINE_METHODS void Controller_Actor::transition3_t1( const void * rtdata, Timing::Base * rtport )
{
	// {{{USR
	south.red().send();
	north.red().send();
	east.green().send();
	west.green().send();
	timer.informIn(RTTimespec( 4, 0) ); 
	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:greenE:J432ED7460363:t1'
INLINE_METHODS void Controller_Actor::transition4_t1( const void * rtdata, Timing::Base * rtport )
{
	// {{{USR
	east.yellow().send();
	west.yellow().send();
	timer.informIn(RTTimespec( 2, 0) ); 
	// }}}USR
}
// }}}RME

INLINE_CHAINS void Controller_Actor::chain1_Initial( void )
{
	// transition ':TOP:Initial:Initial'
	rtgChainBegin( 1, "Initial" );
	rtgTransitionBegin();
	transition1_Initial( msg->data, msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void Controller_Actor::chain2_t1( void )
{
	// transition ':TOP:greenN:J432ED7320101:t1'
	rtgChainBegin( 2, "t1" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition2_t1( msg->data, (Timing::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 3 );
}

INLINE_CHAINS void Controller_Actor::chain3_t1( void )
{
	// transition ':TOP:yellowN:J432ED7430325:t1'
	rtgChainBegin( 3, "t1" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition3_t1( msg->data, (Timing::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 4 );
}

INLINE_CHAINS void Controller_Actor::chain4_t1( void )
{
	// transition ':TOP:greenE:J432ED7460363:t1'
	rtgChainBegin( 4, "t1" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition4_t1( msg->data, (Timing::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 5 );
}

void Controller_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; stateIndex = rtg_parent_state[ stateIndex - 1 ] )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					chain1_Initial();
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		case 2:
			// {{{RME state ':TOP:greenN'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 2:
				// {{{RME port 'timer'
				switch( signalIndex )
				{
				case Timing::Base::rti_timeout:
					chain2_t1();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 3:
			// {{{RME state ':TOP:yellowN'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 2:
				// {{{RME port 'timer'
				switch( signalIndex )
				{
				case Timing::Base::rti_timeout:
					chain3_t1();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 4:
			// {{{RME state ':TOP:greenE'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 2:
				// {{{RME port 'timer'
				switch( signalIndex )
				{
				case Timing::Base::rti_timeout:
					chain4_t1();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 5:
			// {{{RME state ':TOP:yellowE'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			break;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * Controller_Actor::getActorData( void ) const
{
	return &Controller_Actor::rtg_class;
}

const RTActor_class Controller_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 5
  , Controller_Actor::rtg_parent_state
  , &Controller
  , 0
  , (const RTComponentDescriptor *)0
  , 5
  , Controller_Actor::rtg_ports
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId Controller_Actor::rtg_parent_state[] =
{
	0
  , 1
  , 1
  , 1
  , 1
};

const RTPortDescriptor Controller_Actor::rtg_ports[] =
{
	{
		"south"
	  , (const char *)0
	  , &LightControl::Base::rt_class
	  , RTOffsetOf( Controller_Actor, Controller_Actor::south )
	  , 1 // cardinality
	  , 1
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
  , {
		"timer"
	  , (const char *)0
	  , &Timing::Base::rt_class
	  , RTOffsetOf( Controller_Actor, Controller_Actor::timer )
	  , 1 // cardinality
	  , 2
	  , RTPortDescriptor::KindSpecial + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
  , {
		"north"
	  , (const char *)0
	  , &LightControl::Base::rt_class
	  , RTOffsetOf( Controller_Actor, Controller_Actor::north )
	  , 1 // cardinality
	  , 3
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
  , {
		"east"
	  , (const char *)0
	  , &LightControl::Base::rt_class
	  , RTOffsetOf( Controller_Actor, Controller_Actor::east )
	  , 1 // cardinality
	  , 4
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
  , {
		"west"
	  , (const char *)0
	  , &LightControl::Base::rt_class
	  , RTOffsetOf( Controller_Actor, Controller_Actor::west )
	  , 1 // cardinality
	  , 5
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
