// {{{RME classifier 'Logical View::Controller'

#ifndef Controller_H
#define Controller_H

#ifdef PRAGMA
#pragma interface "Controller.h"
#endif

#include <RTSystem/Intersection.h>
#include <LightControl.h>

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR

// }}}USR
// }}}RME

extern const RTActorClass Controller;

#define SUPER RTActor
class Controller_Actor : public RTActor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME port 'south'
	LightControl::Base south;
	// }}}RME
	// {{{RME port 'timer'
	Timing::Base timer;
	// }}}RME
	// {{{RME port 'north'
	LightControl::Base north;
	// }}}RME
	// {{{RME port 'east'
	LightControl::Base east;
	// }}}RME
	// {{{RME port 'west'
	LightControl::Base west;
	// }}}RME

public:
	Controller_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~Controller_Actor( void );
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME transition ':TOP:Initial:Initial'
	INLINE_METHODS void transition1_Initial( const void * rtdata, RTProtocol * rtport );
	// }}}RME
	// {{{RME transition ':TOP:greenN:J432ED7320101:t1'
	INLINE_METHODS void transition2_t1( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:yellowN:J432ED7430325:t1'
	INLINE_METHODS void transition3_t1( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:greenE:J432ED7460363:t1'
	INLINE_METHODS void transition4_t1( const void * rtdata, Timing::Base * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain2_t1( void );
	INLINE_CHAINS void chain3_t1( void );
	INLINE_CHAINS void chain4_t1( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* Controller_H */

// }}}RME
