// {{{RME classifier 'Logical View::Intersection'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Intersection.h"
#endif

#include <RTSystem/Intersection.h>
#include <Intersection.h>
#include <LightControl.h>
extern const RTActorClass Controller;
extern const RTActorClass TrafficLight;

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static RTActor * new_Intersection_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new Intersection_Actor( _rts, _ref );
}

const RTActorClass Intersection =
{
	(const RTActorClass *)0
  , "Intersection"
  , (RTVersionId)0
  , 0
  , (const RTRelayDescriptor *)0
  , new_Intersection_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
};

static const RTInterfaceDescriptor rtg_interfaces_controller[] =
{
	{
		"south"
	  , 1
	}
  , {
		"north"
	  , 1
	}
  , {
		"east"
	  , 1
	}
  , {
		"west"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_controller[] =
{
	{
		0
	  , &LightControl::Conjugate::rt_class
	}
  , {
		1
	  , &LightControl::Conjugate::rt_class
	}
  , {
		2
	  , &LightControl::Conjugate::rt_class
	}
  , {
		3
	  , &LightControl::Conjugate::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_north[] =
{
	{
		"control"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_north[] =
{
	{
		0
	  , &LightControl::Base::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_south[] =
{
	{
		"control"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_south[] =
{
	{
		0
	  , &LightControl::Base::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_east[] =
{
	{
		"control"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_east[] =
{
	{
		0
	  , &LightControl::Base::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_west[] =
{
	{
		"control"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_west[] =
{
	{
		0
	  , &LightControl::Base::rt_class
	}
};

#define SUPER RTActor

Intersection_Actor::Intersection_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

Intersection_Actor::~Intersection_Actor( void )
{
}

int Intersection_Actor::_followOutV( RTBindingEnd & rtg_end, int rtg_compId, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_compId )
	{
	case 1:
		// controller
		switch( rtg_portId )
		{
		case 0:
			// south
			if( rtg_repIndex < 1 )
			{
				// south/control
				return south._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 1:
			// north
			if( rtg_repIndex < 1 )
			{
				// north/control
				return north._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 2:
			// east
			if( rtg_repIndex < 1 )
			{
				// east/control
				return east._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 3:
			// west
			if( rtg_repIndex < 1 )
			{
				// west/control
				return west._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 2:
		// north
		switch( rtg_portId )
		{
		case 0:
			// control
			if( rtg_repIndex < 1 )
			{
				// controller/north
				return controller._followIn( rtg_end, 1, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 3:
		// south
		switch( rtg_portId )
		{
		case 0:
			// control
			if( rtg_repIndex < 1 )
			{
				// controller/south
				return controller._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 4:
		// east
		switch( rtg_portId )
		{
		case 0:
			// control
			if( rtg_repIndex < 1 )
			{
				// controller/east
				return controller._followIn( rtg_end, 2, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 5:
		// west
		switch( rtg_portId )
		{
		case 0:
			// control
			if( rtg_repIndex < 1 )
			{
				// controller/west
				return controller._followIn( rtg_end, 3, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	default:
		break;
	}
	return RTActor::_followOutV( rtg_end, rtg_compId, rtg_portId, rtg_repIndex );
}

void Intersection_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * Intersection_Actor::getActorData( void ) const
{
	return &Intersection_Actor::rtg_class;
}

const RTActor_class Intersection_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 1
  , Intersection_Actor::rtg_parent_state
  , &Intersection
  , 5
  , Intersection_Actor::rtg_capsule_roles
  , 0
  , (const RTPortDescriptor *)0
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId Intersection_Actor::rtg_parent_state[] =
{
	0
};

const RTComponentDescriptor Intersection_Actor::rtg_capsule_roles[] =
{
	{
		"controller"
	  , &Controller
	  , RTOffsetOf( Intersection_Actor, controller )
	  , 1
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 4
	  , rtg_interfaces_controller
	  , 4
	  , rtg_bindings_controller
	}
  , {
		"north"
	  , &TrafficLight
	  , RTOffsetOf( Intersection_Actor, north )
	  , 2
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_north
	  , 1
	  , rtg_bindings_north
	}
  , {
		"south"
	  , &TrafficLight
	  , RTOffsetOf( Intersection_Actor, south )
	  , 3
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_south
	  , 1
	  , rtg_bindings_south
	}
  , {
		"east"
	  , &TrafficLight
	  , RTOffsetOf( Intersection_Actor, east )
	  , 4
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_east
	  , 1
	  , rtg_bindings_east
	}
  , {
		"west"
	  , &TrafficLight
	  , RTOffsetOf( Intersection_Actor, west )
	  , 5
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_west
	  , 1
	  , rtg_bindings_west
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
