// {{{RME classifier 'Logical View::LightControl'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "LightControl.h"
#endif

#include <RTSystem/Intersection.h>
#include <LightControl.h>

const RTProtocolDescriptor LightControl::Base::rt_class =
{
	&RTRootProtocol::rt_class
  , &LightControl::Conjugate::rt_class
  , "LightControl"
  , 0
  , 2
  , LightControl::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor LightControl::Base::rt_signals[] =
{
	{
		"rtBound"
	  , (const RTObject_class *)0
	  , LightControl::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , LightControl::Base::rti_rtUnbound
	}
};

const RTProtocolDescriptor LightControl::Conjugate::rt_class =
{
	&RTRootProtocol::rt_class
  , &LightControl::Base::rt_class
  , "LightControl"
  , 0
  , 5
  , LightControl::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor LightControl::Conjugate::rt_signals[] =
{
	{
		"green"
	  , &RTType_void
	  , LightControl::Conjugate::rti_green
	}
  , {
		"red"
	  , &RTType_void
	  , LightControl::Conjugate::rti_red
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , LightControl::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , LightControl::Conjugate::rti_rtUnbound
	}
  , {
		"yellow"
	  , &RTType_void
	  , LightControl::Conjugate::rti_yellow
	}
};

// }}}RME
