// {{{RME classifier 'Logical View::LightControl'

#ifndef LightControl_H
#define LightControl_H

#ifdef PRAGMA
#pragma interface "LightControl.h"
#endif

#include <RTSystem/Intersection.h>

struct LightControl
{
	class Base : public RTRootProtocol
	{
	public:
		inline Base( void );
		inline ~Base( void );

	protected:
		enum { rtiLast_LightControl = rtiLast_RTRootProtocol };

	public:
		inline RTOutSignal red( void );
		inline RTOutSignal yellow( void );
		inline RTOutSignal green( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RTRootProtocol
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum
		{
			rti_red = rtiLast_RTRootProtocol + 1
		  , rti_yellow
		  , rti_green
		};

	protected:
		enum { rtiLast_LightControl = rti_green };

	public:
		inline RTInSignal red( void );
		inline RTInSignal yellow( void );
		inline RTInSignal green( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline LightControl::Base::Base( void )
	: RTRootProtocol()
{
}

inline LightControl::Base::~Base( void )
{
}

inline RTOutSignal LightControl::Base::red( void )
{
	return RTOutSignal( this, Conjugate::rti_red, (const void *)0, &RTType_void );
}

inline RTOutSignal LightControl::Base::yellow( void )
{
	return RTOutSignal( this, Conjugate::rti_yellow, (const void *)0, &RTType_void );
}

inline RTOutSignal LightControl::Base::green( void )
{
	return RTOutSignal( this, Conjugate::rti_green, (const void *)0, &RTType_void );
}

inline LightControl::Conjugate::Conjugate( void )
	: RTRootProtocol()
{
}

inline LightControl::Conjugate::~Conjugate( void )
{
}

inline RTInSignal LightControl::Conjugate::red( void )
{
	return RTInSignal( this, rti_red );
}

inline RTInSignal LightControl::Conjugate::yellow( void )
{
	return RTInSignal( this, rti_yellow );
}

inline RTInSignal LightControl::Conjugate::green( void )
{
	return RTInSignal( this, rti_green );
}

#endif /* LightControl_H */

// }}}RME
