// {{{RME classifier 'Logical View::TrafficLight'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "TrafficLight.h"
#endif

#include <RTSystem/Intersection.h>
#include <TrafficLight.h>

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"control"
	  , &LightControl::Conjugate::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_TrafficLight_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new TrafficLight_Actor( _rts, _ref );
}

const RTActorClass TrafficLight =
{
	(const RTActorClass *)0
  , "TrafficLight"
  , (RTVersionId)0
  , 1
  , rtg_relays
  , new_TrafficLight_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
  , "Red"
  , "Yellow"
  , "Green"
};

#define SUPER RTActor

TrafficLight_Actor::TrafficLight_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

TrafficLight_Actor::~TrafficLight_Actor( void )
{
}

int TrafficLight_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// control
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &control;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

INLINE_CHAINS void TrafficLight_Actor::chain1_Initial( void )
{
	// transition ':TOP:Initial:Initial'
	rtgChainBegin( 1, "Initial" );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void TrafficLight_Actor::chain2_goGreen( void )
{
	// transition ':TOP:Red:J432EBAF300AC:goGreen'
	rtgChainBegin( 2, "goGreen" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 4 );
}

INLINE_CHAINS void TrafficLight_Actor::chain4_goRed( void )
{
	// transition ':TOP:Yellow:J432EBB83037B:goRed'
	rtgChainBegin( 3, "goRed" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void TrafficLight_Actor::chain3_goYellow( void )
{
	// transition ':TOP:Green:J432EBB1A00BC:goYellow'
	rtgChainBegin( 4, "goYellow" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 3 );
}

void TrafficLight_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; stateIndex = rtg_parent_state[ stateIndex - 1 ] )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					chain1_Initial();
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		case 2:
			// {{{RME state ':TOP:Red'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 1:
				// {{{RME port 'control'
				switch( signalIndex )
				{
				case LightControl::Conjugate::rti_green:
					chain2_goGreen();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 3:
			// {{{RME state ':TOP:Yellow'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 1:
				// {{{RME port 'control'
				switch( signalIndex )
				{
				case LightControl::Conjugate::rti_red:
					chain4_goRed();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 4:
			// {{{RME state ':TOP:Green'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 1:
				// {{{RME port 'control'
				switch( signalIndex )
				{
				case LightControl::Conjugate::rti_yellow:
					chain3_goYellow();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * TrafficLight_Actor::getActorData( void ) const
{
	return &TrafficLight_Actor::rtg_class;
}

const RTActor_class TrafficLight_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 4
  , TrafficLight_Actor::rtg_parent_state
  , &TrafficLight
  , 0
  , (const RTComponentDescriptor *)0
  , 1
  , TrafficLight_Actor::rtg_ports
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId TrafficLight_Actor::rtg_parent_state[] =
{
	0
  , 1
  , 1
  , 1
};

const RTPortDescriptor TrafficLight_Actor::rtg_ports[] =
{
	{
		"control"
	  , (const char *)0
	  , &LightControl::Conjugate::rt_class
	  , RTOffsetOf( TrafficLight_Actor, TrafficLight_Actor::control )
	  , 1 // cardinality
	  , 1
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
