// {{{RME classifier 'Logical View::Client'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Client.h"
#endif

#include <RTSystem/TheSystem.h>
#include <Client.h>

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"link"
	  , &Link::Base::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_Client_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new Client_Actor( _rts, _ref );
}

const RTActorClass Client =
{
	(const RTActorClass *)0
  , "Client"
  , (RTVersionId)0
  , 1
  , rtg_relays
  , new_Client_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
  , "waitForTimer"
  , "waitForResponse"
};

#define SUPER RTActor

Client_Actor::Client_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

Client_Actor::~Client_Actor( void )
{
}

int Client_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// link
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &link;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

// {{{RME transition ':TOP:waitForTimer:Junction1:timeout'
INLINE_METHODS void Client_Actor::transition1_timeout( const void * rtdata, Timing::Base * rtport )
{
	// {{{USR
	link.command().send();

	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:waitForResponse:Junction2:responseRxd'
INLINE_METHODS void Client_Actor::transition2_responseRxd( const void * rtdata, Link::Base * rtport )
{
	// {{{USR
	timer.informIn (RTTimespec (1, 0));

	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:Initial:Initial'
INLINE_METHODS void Client_Actor::transition3_Initial( const void * rtdata, RTProtocol * rtport )
{
	// {{{USR
	timer.informIn (RTTimespec (1, 0));

	// }}}USR
}
// }}}RME

INLINE_CHAINS void Client_Actor::chain3_Initial( void )
{
	// transition ':TOP:Initial:Initial'
	rtgChainBegin( 1, "Initial" );
	rtgTransitionBegin();
	transition3_Initial( msg->data, msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void Client_Actor::chain1_timeout( void )
{
	// transition ':TOP:waitForTimer:Junction1:timeout'
	rtgChainBegin( 2, "timeout" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition1_timeout( msg->data, (Timing::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 3 );
}

INLINE_CHAINS void Client_Actor::chain2_responseRxd( void )
{
	// transition ':TOP:waitForResponse:Junction2:responseRxd'
	rtgChainBegin( 3, "responseRxd" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition2_responseRxd( msg->data, (Link::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

void Client_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; stateIndex = rtg_parent_state[ stateIndex - 1 ] )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					chain3_Initial();
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		case 2:
			// {{{RME state ':TOP:waitForTimer'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 2:
				// {{{RME port 'timer'
				switch( signalIndex )
				{
				case Timing::Base::rti_timeout:
					chain1_timeout();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 3:
			// {{{RME state ':TOP:waitForResponse'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 1:
				// {{{RME port 'link'
				switch( signalIndex )
				{
				case Link::Base::rti_response:
					chain2_responseRxd();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * Client_Actor::getActorData( void ) const
{
	return &Client_Actor::rtg_class;
}

const RTActor_class Client_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 3
  , Client_Actor::rtg_parent_state
  , &Client
  , 0
  , (const RTComponentDescriptor *)0
  , 2
  , Client_Actor::rtg_ports
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId Client_Actor::rtg_parent_state[] =
{
	0
  , 1
  , 1
};

const RTPortDescriptor Client_Actor::rtg_ports[] =
{
	{
		"link"
	  , (const char *)0
	  , &Link::Base::rt_class
	  , RTOffsetOf( Client_Actor, Client_Actor::link )
	  , 1 // cardinality
	  , 1
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
  , {
		"timer"
	  , (const char *)0
	  , &Timing::Base::rt_class
	  , RTOffsetOf( Client_Actor, Client_Actor::timer )
	  , 1 // cardinality
	  , 2
	  , RTPortDescriptor::KindSpecial + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
