// {{{RME classifier 'Logical View::Link'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Link.h"
#endif

#include <RTSystem/TheSystem.h>
#include <Link.h>

const RTProtocolDescriptor Link::Base::rt_class =
{
	&RTRootProtocol::rt_class
  , &Link::Conjugate::rt_class
  , "Link"
  , 0
  , 3
  , Link::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Link::Base::rt_signals[] =
{
	{
		"response"
	  , &RTType_void
	  , Link::Base::rti_response
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Link::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Link::Base::rti_rtUnbound
	}
};

const RTProtocolDescriptor Link::Conjugate::rt_class =
{
	&RTRootProtocol::rt_class
  , &Link::Base::rt_class
  , "Link"
  , 0
  , 3
  , Link::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Link::Conjugate::rt_signals[] =
{
	{
		"command"
	  , &RTType_void
	  , Link::Conjugate::rti_command
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Link::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Link::Conjugate::rti_rtUnbound
	}
};

// }}}RME
