// {{{RME classifier 'Logical View::Link'

#ifndef Link_H
#define Link_H

#ifdef PRAGMA
#pragma interface "Link.h"
#endif

#include <RTSystem/TheSystem.h>

struct Link
{
	class Base : public RTRootProtocol
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum { rti_response = rtiLast_RTRootProtocol + 1 };

	protected:
		enum { rtiLast_Link = rti_response };

	public:
		inline RTInSignal response( void );
		inline RTOutSignal command( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RTRootProtocol
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum { rti_command = rtiLast_RTRootProtocol + 1 };

	protected:
		enum { rtiLast_Link = rti_command };

	public:
		inline RTInSignal command( void );
		inline RTOutSignal response( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline Link::Base::Base( void )
	: RTRootProtocol()
{
}

inline Link::Base::~Base( void )
{
}

inline RTInSignal Link::Base::response( void )
{
	return RTInSignal( this, rti_response );
}

inline RTOutSignal Link::Base::command( void )
{
	return RTOutSignal( this, Conjugate::rti_command, (const void *)0, &RTType_void );
}

inline Link::Conjugate::Conjugate( void )
	: RTRootProtocol()
{
}

inline Link::Conjugate::~Conjugate( void )
{
}

inline RTInSignal Link::Conjugate::command( void )
{
	return RTInSignal( this, rti_command );
}

inline RTOutSignal Link::Conjugate::response( void )
{
	return RTOutSignal( this, Base::rti_response, (const void *)0, &RTType_void );
}

#endif /* Link_H */

// }}}RME
