// {{{RME classifier 'Logical View::Server'

#ifndef Server_H
#define Server_H

#ifdef PRAGMA
#pragma interface "Server.h"
#endif

#include <RTSystem/TheSystem.h>
#include <Link.h>

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR

// }}}USR
// }}}RME

extern const RTActorClass Server;

#define SUPER RTActor
class Server_Actor : public RTActor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME port 'link'
	Link::Conjugate link;
	// }}}RME
	// {{{RME port 'timer'
	Timing::Base timer;
	// }}}RME

public:
	Server_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~Server_Actor( void );
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME transition ':TOP:waitForCommand:Junction2:commandRxd'
	INLINE_METHODS void transition2_commandRxd( const void * rtdata, Link::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:waitForTimer:Junction2:timeout'
	INLINE_METHODS void transition3_timeout( const void * rtdata, Timing::Base * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain2_commandRxd( void );
	INLINE_CHAINS void chain3_timeout( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* Server_H */

// }}}RME
