// {{{RME classifier 'Logical View::TheSystem'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "TheSystem.h"
#endif

#include <RTSystem/TheSystem.h>
#include <TheSystem.h>
#include <Link.h>
extern const RTActorClass Client;
extern const RTActorClass Server;

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static RTActor * new_TheSystem_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new TheSystem_Actor( _rts, _ref );
}

const RTActorClass TheSystem =
{
	(const RTActorClass *)0
  , "TheSystem"
  , (RTVersionId)0
  , 0
  , (const RTRelayDescriptor *)0
  , new_TheSystem_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
  , "Active"
};

static const RTInterfaceDescriptor rtg_interfaces_client[] =
{
	{
		"link"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_client[] =
{
	{
		0
	  , &Link::Conjugate::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_server[] =
{
	{
		"link"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_server[] =
{
	{
		0
	  , &Link::Base::rt_class
	}
};

#define SUPER RTActor

TheSystem_Actor::TheSystem_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

TheSystem_Actor::~TheSystem_Actor( void )
{
}

int TheSystem_Actor::_followOutV( RTBindingEnd & rtg_end, int rtg_compId, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_compId )
	{
	case 1:
		// client
		switch( rtg_portId )
		{
		case 0:
			// link
			if( rtg_repIndex < 1 )
			{
				// server/link
				return server._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 2:
		// server
		switch( rtg_portId )
		{
		case 0:
			// link
			if( rtg_repIndex < 1 )
			{
				// client/link
				return client._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	default:
		break;
	}
	return RTActor::_followOutV( rtg_end, rtg_compId, rtg_portId, rtg_repIndex );
}

// {{{RME transition ':TOP:Initial:Initial'
INLINE_METHODS void TheSystem_Actor::transition1_Initial( const void * rtdata, RTProtocol * rtport )
{
	// {{{USR
	frame.incarnate(client);
	// }}}USR
}
// }}}RME

INLINE_CHAINS void TheSystem_Actor::chain1_Initial( void )
{
	// transition ':TOP:Initial:Initial'
	rtgChainBegin( 1, "Initial" );
	rtgTransitionBegin();
	transition1_Initial( msg->data, msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

void TheSystem_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; stateIndex = rtg_parent_state[ stateIndex - 1 ] )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					chain1_Initial();
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		case 2:
			// {{{RME state ':TOP:Active'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			break;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * TheSystem_Actor::getActorData( void ) const
{
	return &TheSystem_Actor::rtg_class;
}

const RTActor_class TheSystem_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 2
  , TheSystem_Actor::rtg_parent_state
  , &TheSystem
  , 2
  , TheSystem_Actor::rtg_capsule_roles
  , 1
  , TheSystem_Actor::rtg_ports
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId TheSystem_Actor::rtg_parent_state[] =
{
	0
  , 1
};

const RTComponentDescriptor TheSystem_Actor::rtg_capsule_roles[] =
{
	{
		"client"
	  , &Client
	  , RTOffsetOf( TheSystem_Actor, client )
	  , 1
	  , RTComponentDescriptor::Optional
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_client
	  , 1
	  , rtg_bindings_client
	}
  , {
		"server"
	  , &Server
	  , RTOffsetOf( TheSystem_Actor, server )
	  , 2
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_server
	  , 1
	  , rtg_bindings_server
	}
};

const RTPortDescriptor TheSystem_Actor::rtg_ports[] =
{
	{
		"frame"
	  , (const char *)0
	  , &Frame::Base::rt_class
	  , RTOffsetOf( TheSystem_Actor, TheSystem_Actor::frame )
	  , 1 // cardinality
	  , 1
	  , RTPortDescriptor::KindSpecial + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
